
with Interfaces.C.Strings;              use Interfaces.C.Strings;

package body Allegro.Datafiles is

    function Create_Datafile_Index( filename : String ) return A_Datafile_Index is

        function C_Create_Datafile_Index( filename : C.char_array ) return A_Datafile_Index;
        pragma Import( C, C_Create_Datafile_Index, "create_datafile_index" );

    begin
        return C_Create_Datafile_Index( To_C( filename ) );
    end Create_Datafile_Index;

    ----------------------------------------------------------------------------

    procedure Destroy_Datafile_Index( index : in out A_Datafile_Index ) is

        procedure C_Destroy_Datafile_Index( index : A_Datafile_Index );
        pragma Import( C, C_Destroy_Datafile_Index, "destroy_datafile_index" );

    begin
        if index /= Null_Address then
            C_Destroy_Datafile_Index( index );
            index := Null_Address;
        end if;
    end Destroy_Datafile_Index;

    ----------------------------------------------------------------------------

    function Find_Datafile_Object( dat        : not null A_Datafile;
                                   objectname : String ) return A_Datafile is

        function C_Find_Datafile_Object( dat        : A_Datafile;
                                         objectname : C.char_array ) return A_Datafile;
        pragma Import( C, C_Find_Datafile_Object, "find_datafile_object" );

    begin
        return C_Find_Datafile_Object( dat, To_C( objectname ) );
    end Find_Datafile_Object;

    ----------------------------------------------------------------------------

    function Get_Datafile_Property( dat : not null A_Datafile;
                                    typ : DAT_ID ) return String is

        function C_Get_Datafile_Property( dat : A_Datafile;
                                          typ : DAT_ID ) return C.Strings.chars_ptr;
        pragma Import( C, C_Get_Datafile_Property, "get_datafile_property" );

    begin
        return To_Ada( Value( C_Get_Datafile_Property( dat, typ ) ) );
    end Get_Datafile_Property;

    ----------------------------------------------------------------------------

    function Load_Datafile( filename : String ) return A_Datafile is

        function C_Load_Datafile( filename : C.char_array ) return A_Datafile;
        pragma Import( C, C_Load_Datafile, "load_datafile" );

    begin
        return C_Load_Datafile( To_C( filename ) );
    end Load_Datafile;

    ----------------------------------------------------------------------------

    function Load_Datafile_Callback( filename : String;
                                     callback : not null A_Datafile_Examiner
                                   ) return A_Datafile is

        function C_Load_Datafile_Callback( filename : C.char_array;
                                           callback : A_Datafile_Examiner
                                         ) return A_Datafile;
        pragma Import( C, C_Load_Datafile_Callback, "load_datafile_callback" );

    begin
        return C_Load_Datafile_Callback( To_C( filename ), callback );
    end Load_Datafile_Callback;

    ----------------------------------------------------------------------------

    function Load_Datafile_Object( filename   : String;
                                   objectname : String ) return A_Datafile is

        function C_Load_Datafile_Object( filename,
                                         objectname : C.char_array ) return A_Datafile;
        pragma Import( C, C_Load_Datafile_Object, "load_datafile_object" );

    begin
        return C_Load_Datafile_Object( To_C( filename ), To_C( objectname ) );
    end Load_Datafile_Object;

    ----------------------------------------------------------------------------

    function To_DAT_ID( a, b, c, d : Character ) return DAT_ID is
    begin
        return To_AL_ID( a, b, c, d );
    end To_DAT_ID;

    ----------------------------------------------------------------------------

    procedure Unload_Datafile( dat : in out A_Datafile ) is

        procedure C_Unload_Datafile( dat : A_Datafile );
        pragma Import( C, C_Unload_Datafile, "unload_datafile" );

    begin
        if dat /= null then
            C_Unload_Datafile( dat );
            dat := null;
        end if;
    end Unload_Datafile;

    ----------------------------------------------------------------------------

    procedure Unload_Datafile_Object( dat : in out A_Datafile ) is

        procedure C_Unload_Datafile_Object( dat : A_Datafile );
        pragma Import( C, C_Unload_Datafile_Object, "unload_datafile_object" );

    begin
        if dat /= null then
            C_Unload_Datafile_Object( dat );
            dat := null;
        end if;
    end Unload_Datafile_Object;

end Allegro.Datafiles;
