
package body Allegro.Digital_Samples is

    procedure Destroy_Sample( spl : in out A_Sample ) is

        procedure C_Destroy_Sample( spl : A_Sample );
        pragma Import( C, C_Destroy_Sample, "destroy_sample" );

    begin
        if spl /= null then
            C_Destroy_Sample( spl );
            spl := null;
        end if;
    end Destroy_Sample;

    ----------------------------------------------------------------------------

    function Load_Sample( filename : String ) return A_Sample is

        function C_Load_Sample( filename : C.char_array ) return A_Sample;
        pragma Import( C, C_Load_Sample, "load_sample" );

    begin
        return C_Load_Sample( To_C( filename ) );
    end Load_Sample;

    ----------------------------------------------------------------------------

    function Load_Voc( filename : String ) return A_Sample is

        function C_Load_Voc( filename : C.char_array ) return A_Sample;
        pragma Import( C, C_Load_Voc, "load_voc" );

    begin
        return C_Load_Voc( To_C( filename ) );
    end Load_Voc;

    ----------------------------------------------------------------------------

    function Load_Wav( filename : String ) return A_Sample is

        function C_Load_Wav( filename : C.char_array ) return A_Sample;
        pragma Import( C, C_Load_Wav, "load_wav" );

    begin
        return C_Load_Wav( To_C( filename ) );
    end Load_Wav;

    ----------------------------------------------------------------------------

    procedure Register_Sample_File_Type( ext : String;
                                         load : A_Sample_Loader;
                                         save : A_Sample_Saver ) is

        procedure C_Register_Sample_File_Type( ext  : C.char_array;
                                               load : A_Sample_Loader;
                                               save : A_Sample_Saver );
        pragma Import( C, C_Register_Sample_File_Type, "register_sample_file_type" );

    begin
        C_Register_Sample_File_Type( To_C( ext ), load, save );
    end Register_Sample_File_Type;

    ----------------------------------------------------------------------------

    function Save_Sample( filename : String; spl : not null A_Sample ) return Boolean is

        function C_Save_Sample( filename : C.char_array; spl : A_Sample ) return Integer;
        pragma Import( C, C_Save_Sample, "save_sample" );

    begin
        return C_Save_Sample( To_C( filename ), spl ) = 0;
    end Save_Sample;

end Allegro.Digital_Samples;
