
with Allegro.Bitmaps;                   use Allegro.Bitmaps;
with Allegro.Fonts;                     use Allegro.Fonts;
with Allegro.Truecolor;                 use Allegro.Truecolor;

-- Allegro 4.4.2 - Text output
-- This package is missing:
-- textprintf_ex, textprintf_centre_ex, textprintf_right_ex
-- textprintf_justify_ex
package Allegro.Text_IO is

    function Get_Allegro_404_Char return Integer;

    function Get_Font return A_Font;

    procedure Set_Allegro_404_Char( c : Integer );

    procedure Set_Font( f : A_Font );

    function Text_Height( f : not null A_Font ) return Natural;

    function Text_Length( f : not null A_Font; str : String ) return Natural;

    procedure Textout_Ex( bmp   : not null A_Bitmap;
                          f     : not null A_Font;
                          s     : String;
                          x, y  : Integer;
                          color : Color_Type;
                          bg    : Integer );

    procedure Textout_Centre_Ex( bmp   : not null A_Bitmap;
                                 f     : not null A_Font;
                                 s     : String;
                                 x, y  : Integer;
                                 color : Color_Type;
                                 bg    : Integer );

    procedure Textout_Justify_Ex( bmp    : not null A_Bitmap;
                                  f      : not null A_Font;
                                  s      : String;
                                  x1, x2 : Integer;
                                  y      : Integer;
                                  diff   : Integer;
                                  color  : Color_Type;
                                  bg     : Integer );

    procedure Textout_Right_Ex( bmp   : not null A_Bitmap;
                                f     : not null A_Font;
                                s     : String;
                                x, y  : Integer;
                                color : Color_Type;
                                bg    : Integer );

private

    pragma Import( C, Get_Allegro_404_Char, "get_allegro_404_char" );
    pragma Import( C, Get_Font, "get_font" );
    pragma Import( C, Set_Allegro_404_Char, "set_allegro_404_char" );
    pragma Import( C, Set_Font, "set_font" );
    pragma Import( C, Text_Height, "text_height" );

end Allegro.Text_IO;
