
package body Expressions.Literals is

    function Create_Literal( token : not null A_Token ) return A_Literal is
        this  : A_Literal := null;
        value : A_Value;
    begin
        case token.Get_Type is
            when TK_NUMBER =>
                this := new Literal;
                value := Create_Value( Integer(A_Number_Token(token).Get_Value) );
                this.Construct( token.Get_Location, value );  -- consumes value

            when TK_STRING =>
                this := new Literal;
                value := Create_Value( A_String_Token(token).Get_Value );
                this.Construct( token.Get_Location, value );  -- consumes value

            when others => null;
        end case;
        return this;
    end Create_Literal;

    ----------------------------------------------------------------------------

    not overriding
    procedure Construct( this  : access Literal;
                         loc   : Token_Location;
                         value : in out A_Value ) is
    begin
        Expression(this.all).Construct( loc );
        this.value := value;
        value := null;
    end Construct;

    ----------------------------------------------------------------------------

    overriding
    procedure Delete( this : in out Literal ) is
    begin
        Delete( this.value );
        Expression(this).Delete;
    end Delete;

    ----------------------------------------------------------------------------

    overriding
    function Evaluate( this    : access Literal;
                       context : not null A_Eval_Context ) return A_Value is
        pragma Unreferenced( context );
    begin
       return Copy( this.value );
    end Evaluate;

end Expressions.Literals;
