
package body Expressions is

    function Create_Eval_Context( resolver : A_Symbol_Resolver ) return A_Eval_Context is
    begin
        return new Eval_Context'(resolver => resolver);
    end Create_Eval_Context;

    ----------------------------------------------------------------------------

    function Resolve( this : access Eval_Context; symbol : String ) return A_Value is
    begin
        if this.resolver /= null then
            return this.resolver.Resolve( symbol );
        else
            return null;
        end if;
    end Resolve;

    --==========================================================================

    not overriding
    procedure Construct( this : access Expression; loc : Token_Location ) is
    begin
        Limited_Object(this.all).Construct;
        this.loc := loc;
    end Construct;

    ----------------------------------------------------------------------------

    not overriding
    function Evaluate( this    : access Expression;
                       context : not null A_Eval_Context ) return A_Value is
        pragma Unreferenced( context );
    begin
       raise Constraint_Error with
           "Evaluate not implemented for " & this.Get_Class_Name;
       return null;
    end Evaluate;

    ----------------------------------------------------------------------------

    procedure Delete( this : in out A_Expression ) is
    begin
        Delete( A_Limited_Object(this) );
    end Delete;

end Expressions;
