
package Game_Views.Window_Hooks is

    -- Returns True on the first call after the user attempts to close the
    -- application window. In Windows, this is when the user clicks the close
    -- button on the window or presses Alt+F4. In OS X, this is when the user
    -- clicks the red close button on the window, presses Apple+Q, or selects
    -- Quit from the application's menu bar.
    function Close_Window_Clicked return Boolean;

    -- Registers window behavior hooks with Allegro.
    procedure Initialize;

    -- Unregisters the window behavior hooks with Allegro.
    procedure Finalize;

private

    -- Called when the close button on the application window is clicked.
    procedure Close_Window_Callback;
    pragma Convention( C, Close_Window_Callback );

    -- Called when the application window regains focus.
    procedure Switch_In_Callback;
    pragma Convention( C, Switch_In_Callback );

    -- Called when the application window loses focus.
    procedure Switch_Out_Callback;
    pragma Convention( C, Switch_Out_Callback );

end Game_Views.Window_Hooks;
