
package body Physics.Drawing is

    procedure Draw( dc      : Drawing_Context;
                    cType   : Clip_Type;
                    x, y    : Integer;
                    size    : Positive;
                    color   : Color_Type;
                    opacity : Natural := 255 ) is
    begin
        case cType is
            when Passive =>
                null;
            when OneWay =>
                Rectfill( dc, x, y, x + size - 1, y + size / 2 - 1, color, opacity );
            when Wall =>
                Rectfill( dc, x, y, x + size - 1, y + size - 1, color, opacity );
            when Slope_45_Up_Floor =>
                Triangle( dc,
                          x, y + size - 1,                 --     2
                          x + size - 1, y,                 --   / |
                          x + size - 1, y + size - 1,      -- 1---3
                          color, opacity );
            when Slope_45_Up_Ceiling =>
                Triangle( dc,
                          x, y,                            -- 1---2
                          x + size - 1, y,                 -- | /
                          x, y + size - 1,                 -- 3
                          color, opacity );
            when Slope_45_Down_Floor =>
                Triangle( dc,
                          x, y,                            -- 1
                          x + size - 1, y + size - 1,      -- | \
                          x, y + size - 1,                 -- 3---2
                          color, opacity );
            when Slope_45_Down_Ceiling =>
                Triangle( dc,
                          x, y,                            -- 1---2
                          x + size - 1, y,                 --   \ |
                          x + size - 1, y + size - 1,      --     3
                          color, opacity );
            when Slope_22_Up_Floor_Thin =>
                Triangle( dc,
                          x, y + size - 1,                 --
                          x + size - 1, y + size / 2 - 1,  --   ..2
                          x + size - 1, y + size - 1,      -- 1---3
                          color, opacity );
            when Slope_22_Up_Floor_Wide =>
                Triangle( dc,
                          x, y + size / 2 - 1,             --   ..2
                          x + size - 1, y,                 -- 1---3
                          x + size - 1, y + size / 2 - 1,  -- #####
                          color, opacity );
                Rectfill( dc,
                          x, y + size / 2 - 1,
                          x + size - 1, y + size - 1,
                          color, opacity );
            when Slope_22_Up_Ceiling_Wide =>
                Triangle( dc,
                          x, y + size / 2 - 1,             -- #####
                          x + size - 1, y + size / 2 - 1,  -- 1---2
                          x, y + size - 1,                 -- 3''
                          color, opacity );
                Rectfill( dc,
                          x, y,
                          x + size - 1, y + size / 2 - 1,
                          color, opacity );
            when Slope_22_Up_Ceiling_Thin =>
                Triangle( dc,
                          x, y,                            -- 1---2
                          x + size - 1, y,                 -- 3''
                          x, y + size / 2 - 1,             --
                          color, opacity );
            when Slope_22_Down_Floor_Wide =>
                Triangle( dc,
                          x, y,                            -- 1..
                          x + size - 1, y + size / 2 - 1,  -- 3---2
                          x, y + size / 2 - 1,             -- #####
                          color, opacity );
                Rectfill( dc,
                          x, y + size / 2 - 1,
                          x + size - 1, y + size - 1,
                          color, opacity );
            when Slope_22_Down_Floor_Thin =>
                Triangle( dc,
                          x, y + size / 2 - 1,             --
                          x + size - 1, y + size - 1,      -- 1..
                          x, y + size - 1,                 -- 3---2
                          color, opacity );
            when Slope_22_Down_Ceiling_Thin =>
                Triangle( dc,
                          x, y,                            -- 1---2
                          x + size - 1, y,                 --   ''3
                          x + size - 1, y + size / 2 - 1,  --
                          color, opacity );
            when Slope_22_Down_Ceiling_Wide =>
                Triangle( dc,
                          x, y + size / 2 - 1,             -- #####
                          x + size - 1, y + size / 2 - 1,  -- 1---2
                          x + size - 1, y + size - 1,      --   ''3
                          color, opacity );
                Rectfill( dc,
                          x, y,
                          x + size - 1, y + size / 2 - 1,
                          color, opacity );
        end case;
    end Draw;

end Physics.Drawing;
