
with Allegro.Truecolor;                 use Allegro.Truecolor;
with Drawing_Contexts;                  use Drawing_Contexts;

package Physics.Drawing is

    -- Draws the clipping shape of a tile at x, y on the given context. The
    -- clipping shape is determined by the tile's clipping type in 'cType'.
    -- 'size' is the width/height of the tile in pixels.
    procedure Draw( dc      : Drawing_Context;
                    cType   : Clip_Type;
                    x, y    : Integer;
                    size    : Positive;
                    color   : Color_Type;
                    opacity : Natural := 255 );
    pragma Precondition( opacity <= 255 );

end Physics.Drawing;
