
with Debugging;                         use Debugging;
with Engine_Debugging;                  use Engine_Debugging;

package body Themes.Palette is

    initialized : Boolean := False;

    ----------------------------------------------------------------------------

    procedure Initialize is
    begin
        if not initialized then
            pragma Debug( Dbg( "Initializing palette", D_INIT, INFO ) );

            base_colors(Black)       := Makeacol( 16#00#, 16#00#, 16#00#, 255 );
            base_colors(White)       := Makeacol( 16#FF#, 16#FF#, 16#FF#, 255 );
            base_colors(Transparent) := Makeacol( 16#FF#, 16#00#, 16#FF#, 0 );
            base_colors(Magenta)     := Makeacol( 16#FE#, 16#00#, 16#FE#, 255 );

            base_colors(Butter1) := Makeacol( 16#FC#, 16#E9#, 16#4F#, 255 );
            base_colors(Butter2) := Makeacol( 16#ED#, 16#D4#, 16#00#, 255 );
            base_colors(Butter3) := Makeacol( 16#C4#, 16#A0#, 16#00#, 255 );

            base_colors(Orange1) := Makeacol( 16#FC#, 16#AF#, 16#3E#, 255 );
            base_colors(Orange2) := Makeacol( 16#F5#, 16#79#, 16#00#, 255 );
            base_colors(Orange3) := Makeacol( 16#CE#, 16#5C#, 16#00#, 255 );

            base_colors(Chocolate1) := Makeacol( 16#E9#, 16#B9#, 16#6E#, 255 );
            base_colors(Chocolate2) := Makeacol( 16#C1#, 16#7D#, 16#11#, 255 );
            base_colors(Chocolate3) := Makeacol( 16#8F#, 16#59#, 16#02#, 255 );

            base_colors(Chameleon1) := Makeacol( 16#8A#, 16#E2#, 16#34#, 255 );
            base_colors(Chameleon2) := Makeacol( 16#73#, 16#D2#, 16#16#, 255 );
            base_colors(Chameleon3) := Makeacol( 16#4E#, 16#9A#, 16#06#, 255 );

            base_colors(Skyblue1) := Makeacol( 16#72#, 16#9F#, 16#CF#, 255 );
            base_colors(Skyblue2) := Makeacol( 16#34#, 16#65#, 16#A4#, 255 );
            base_colors(Skyblue3) := Makeacol( 16#20#, 16#4A#, 16#87#, 255 );

            base_colors(Plum1) := Makeacol( 16#AD#, 16#7F#, 16#A8#, 255 );
            base_colors(Plum2) := Makeacol( 16#75#, 16#50#, 16#7B#, 255 );
            base_colors(Plum3) := Makeacol( 16#5C#, 16#35#, 16#66#, 255 );

            base_colors(Scarlet1) := Makeacol( 16#EF#, 16#29#, 16#29#, 255 );
            base_colors(Scarlet2) := Makeacol( 16#CC#, 16#00#, 16#00#, 255 );
            base_colors(Scarlet3) := Makeacol( 16#A4#, 16#00#, 16#00#, 255 );

            base_colors(Chrome1) := Makeacol( 16#EE#, 16#EE#, 16#EC#, 255 );
            base_colors(Chrome2) := Makeacol( 16#D3#, 16#D7#, 16#CF#, 255 );
            base_colors(Chrome3) := Makeacol( 16#BA#, 16#BD#, 16#B6#, 255 );
            base_colors(Chrome4) := Makeacol( 16#88#, 16#8A#, 16#85#, 255 );
            base_colors(Chrome5) := Makeacol( 16#55#, 16#57#, 16#53#, 255 );
            base_colors(Chrome6) := Makeacol( 16#2E#, 16#34#, 16#36#, 255 );

            initialized := True;
        end if;
    end Initialize;

end Themes.Palette;
