
private with Widgets.Buttons;
private with Widgets.Input_Boxes;

package Widgets.Containers.Panels.Dialogs.New_World is

    function Create_New_Dialog( view : not null access Game_Views.Game_View'Class;
                                id   : String ) return A_Dialog;
    pragma Precondition( id'Length > 0 );
    pragma Postcondition( Create_New_Dialog'Result /= null );

private

    use Widgets.Buttons;
    use Widgets.Input_Boxes;

    type New_Dialog is new Dialog and
         Button_Listener and
         Input_Listener with null record;

    procedure Construct( this : access New_Dialog;
                         view : not null access Game_Views.Game_View'Class;
                         id   : String );
    pragma Precondition( id'Length > 0 );

    procedure Do_Ok( this : access New_Dialog );

    procedure Handle_Action( this   : access New_Dialog;
                             action : A_Button_Action );

    procedure Handle_Action( this   : access New_Dialog;
                             action : A_Input_Action );

    procedure Handle_Action( this    : access New_Dialog;
                             action  : A_Key_Action;
                             handled : out Boolean );

    procedure Handle_Show( this : access New_Dialog );

    procedure Show( this : access New_Dialog );

end Widgets.Containers.Panels.Dialogs.New_World;
