
with Ada.Tags;                          use Ada.Tags;
with Actors;
--with Debugging;                         use Debugging;
with Entities.Enemies.Keen4;            use Entities.Enemies.Keen4;

pragma Elaborate_All( Actors );

package body Actors.Keen4 is

    function Create_Arachnut return A_Actor is
        this : constant A_Arachnut_Actor := new Arachnut_Actor;
    begin
        this.Construct;
        return A_Actor(this);
    end Create_Arachnut;

    ----------------------------------------------------------------------------

    overriding
    procedure Impulse( this : access Arachnut_Actor; name : Hashed_String ) is
        pragma Unreferenced( this, name );
    begin
        null;
    end Impulse;

    --==========================================================================

    function Create_Bounder return A_Actor is
        this : constant A_Bounder_Actor := new Bounder_Actor;
    begin
        this.Construct;
        return A_Actor(this);
    end Create_Bounder;

    ----------------------------------------------------------------------------

    overriding
    procedure Impulse( this : access Bounder_Actor; name : Hashed_String ) is
        pragma Unreferenced( this, name );
    begin
        null;
    end Impulse;

    --==========================================================================

    function Create_Cloud return A_Actor is
        this : constant A_Cloud_Actor := new Cloud_Actor;
    begin
        this.Construct;
        return A_Actor(this);
    end Create_Cloud;

    ----------------------------------------------------------------------------

    overriding
    procedure Impulse( this : access Cloud_Actor; name : Hashed_String ) is
        pragma Unreferenced( this, name );
    begin
        null;
    end Impulse;

    --==========================================================================

    function Create_Inchworm return A_Actor is
        this : constant A_Inchworm_Actor := new Inchworm_Actor;
    begin
        this.Construct;
        return A_Actor(this);
    end Create_Inchworm;

    ----------------------------------------------------------------------------

    overriding
    procedure Impulse( this : access Inchworm_Actor; name : Hashed_String ) is
        pragma Unreferenced( this, name );
    begin
        null;
    end Impulse;

    --==========================================================================

    function Create_Lick return A_Actor is
        this : constant A_Lick_Actor := new Lick_Actor;
    begin
        this.Construct;
        return A_Actor(this);
    end Create_Lick;

    ----------------------------------------------------------------------------

    overriding
    procedure Impulse( this : access Lick_Actor; name : Hashed_String ) is
        pragma Unreferenced( this, name );
    begin
        null;
    end Impulse;

    --==========================================================================

    function Create_Mimrock return A_Actor is
        this : constant A_Mimrock_Actor := new Mimrock_Actor;
    begin
        this.Construct;
        return A_Actor(this);
    end Create_Mimrock;

    ----------------------------------------------------------------------------

    overriding
    procedure Impulse( this : access Mimrock_Actor; name : Hashed_String ) is
        pragma Unreferenced( this, name );
    begin
        null;
    end Impulse;

    --==========================================================================

    function Create_Mushroom return A_Actor is
        this : constant A_Mushroom_Actor := new Mushroom_Actor;
    begin
        this.Construct;
        return A_Actor(this);
    end Create_Mushroom;

    ----------------------------------------------------------------------------

    overriding
    procedure Impulse( this : access Mushroom_Actor; name : Hashed_String ) is
        pragma Unreferenced( this, name );
    begin
        null;
    end Impulse;

    --==========================================================================

    function Create_Slug return A_Actor is
        this : constant A_Slug_Actor := new Slug_Actor;
    begin
        this.Construct;
        return A_Actor(this);
    end Create_Slug;

    ----------------------------------------------------------------------------

    overriding
    procedure Impulse( this : access Slug_Actor; name : Hashed_String ) is
        pragma Unreferenced( this, name );
    begin
        null;
    end Impulse;

    --==========================================================================

    function Create_Snake return A_Actor is
        this : constant A_Snake_Actor := new Snake_Actor;
    begin
        this.Construct;
        return A_Actor(this);
    end Create_Snake;

    ----------------------------------------------------------------------------

    overriding
    procedure Impulse( this : access Snake_Actor; name : Hashed_String ) is
        pragma Unreferenced( this, name );
    begin
        null;
    end Impulse;

begin

    Actors.Factory.Register_Class( External_Tag( Entities.Enemies.Keen4.Arachnut'Tag ), Create_Arachnut'Access );
    Actors.Factory.Register_Class( External_Tag( Entities.Enemies.Keen4.Bounder'Tag ),  Create_Bounder'Access );
    Actors.Factory.Register_Class( External_Tag( Entities.Enemies.Keen4.Cloud'Tag ),    Create_Cloud'Access );
    Actors.Factory.Register_Class( External_Tag( Entities.Enemies.Keen4.Inchworm'Tag ), Create_Inchworm'Access );
    Actors.Factory.Register_Class( External_Tag( Entities.Enemies.Keen4.Lick'Tag ),     Create_Lick'Access );
    Actors.Factory.Register_Class( External_Tag( Entities.Enemies.Keen4.Mimrock'Tag ),  Create_Mimrock'Access );
    Actors.Factory.Register_Class( External_Tag( Entities.Enemies.Keen4.Mushroom'Tag ), Create_Mushroom'Access );
    Actors.Factory.Register_Class( External_Tag( Entities.Enemies.Keen4.Slug'Tag ),     Create_Slug'Access );
    Actors.Factory.Register_Class( External_Tag( Entities.Enemies.Keen4.Snake'Tag ),    Create_Snake'Access );

end Actors.Keen4;
